<HTML>
<HEAD>
<TITLE>Tree Editor</TITLE>
<link rel="StyleSheet" href="css/main.css" type="text/css">
</HEAD>
<BODY>

<?php
require_once ("paths.inc.php");
//require_once ($path_root."lib/octoploid/php/basic_set_up.inc.php");
//require_once ($path_lib_main_php."header.inc.php");
//require_once ($path_lib_main_php."include_pear.inc.php");
//require_once ($path_lib_main_php."config.inc.php");
//require_once ($path_lib_main_php."utilities_get_and_post.inc.php");
//require_once ($path_lib_main_php."safe_text_to_html.inc.php");

//$script_name = $_SERVER['SCRIPT_NAME'];
//$app_name = "Tree Editor";
//include_header_top($path_root, $path_app, $app_name);
//title_image($path_root);
//render_app_title($app_name);

$tree_root = $path_root.'lib/tree/';
include_once($tree_root."php/tree_factory.class.php");
$tree_factory = new tree_factory($tree_root);
?>
<style>
.black       { background-Color:black }
.transparent { background-Color: }
.title_main {
  color: #4040FF;
  width:100%;
  height:65;
  font-size:32pt;
  font-weight:bold;
  filter:shadow(color="black", strength=10, direction=135)glow(color="black", strength=1);
}
.title_first {
  color: #6060FF;
  width:100%;
  height:45;
  font-size:20pt;
  font-weight:bold;
  filter:shadow(color="black", strength=3, direction=135)glow(color="black", strength=1);
}
.heading {
  color: #2020C0;
  font-weight:bold;
}
.sub_heading {
  color: #004000;
  font-weight:normal;
}

</style>

<Table cellpadding="0" cellspacing="0" BORDER="0" width="100%" HEIGHT="100%">
<TR>
<TD>

<CENTER>
<Table cellpadding="0" cellspacing="0" BORDER="0" WIDTH="95%" HEIGHT="100%">
<TR>
<TD ALIGN="LEFT" WIDTH="100%">

<CENTER>
<DIV class="title_main">Tree Editor&nbsp;</DIV>
</CENTER>

<center>
<table>
<TR>

<TD>
<table cellpadding="0" cellspacing="0" border="2"><TR><TD><img src="graphics/thumb_old_tree.jpg" width="64" height="64" border=1></TD></TR></table>
</TD>

<TD>
<table cellpadding="0" cellspacing="0" border="2"><TR><TD><img src="graphics/thumb_riverine.jpg" width="64" height="64" border=1></TD></TR></table>
</TD>

<TD>
<table cellpadding="0" cellspacing="0" border="2"><TR><TD><img src="graphics/thumb_coral.jpg" width="64" height="64" border=1></TD></TR></table>
</TD>

<TD>
<table cellpadding="0" cellspacing="0" border="2"><TR><TD><img src="graphics/thumb_tree.jpg" width="64" height="64" border=1></TD></TR></table>
</TD>

<TD>
<table cellpadding="0" cellspacing="0" border="2"><TR><TD><img src="graphics/thumb_leaf.jpg" width="64" height="64" border=1></TD></TR></table>
</TD>

<TD>
<table cellpadding="0" cellspacing="0" border="2"><TR><TD><img src="graphics/thumb_diagram.jpg" width="64" height="64" border=1></TD></TR></table>
</TD>

<TD>
<table cellpadding="0" cellspacing="0" border="2"><TR><TD><img src="graphics/tree_editor.png" width="64" height="64" border=1></TD></TR></table>
</TD>

</TR></table></center>

<CENTER>
<table>
<TR>
<TD>

<?php

$tree = $tree_factory -> web_tree("f");

$tree -> collapse_beyond_level(2);

$tree -> collapse_all();
$tree -> open_as_far_as(2);
$tree -> expand_all();
?>

<?php $tree -> directory(); ?>
<DIV class="heading">Introduction</DIV><?php $tree -> node_last(); ?>
This site offers:<BR>

<?php
$tree2 = $tree_factory -> web_tree("f");
$tree2 -> collapse_beyond_level(2);
$tree2 -> collapse_all();
$tree2 -> expand_all();
?>

<?php $tree2 -> directory(); ?>
<DIV class="sub_heading">A tree viewer:</DIV>

<?php $tree2 -> node_last(); ?>
...which displays collapsable, heirarchical tree structures on web pages;

<?php $tree2 -> directory_last(); ?>
<DIV class="sub_heading">A tree editor:</DIV>

<?php $tree2 -> node_last(); ?>

...which allows heirarchical tree structures to be created and manipulated
using a web browser.

<?php $tree2 -> node_end(); ?>

<?php $tree -> directory(); ?>
<DIV class="heading">Technology overview</DIV>

<?php $tree -> node(); ?>
The tree display is generated on the server using PHP;<BR>

<?php $tree -> node(); ?>
It's rendered on the client using JavaScript and DHTML;<BR>

<?php $tree -> directory_last(); ?>
More details...

<?php $tree -> node(); ?>
The tree editor manipulates a representation of the tree in a
standard SQL database;

<?php $tree -> node(); ?>
The tree editor uses a double database abstraction layer;

<?php $tree -> node(); ?>
By default, the editor is set up to access MySQL via Pear - but other
configurations are possible;

<?php $tree -> node(); ?>
Trees can be rendered directly from database tables via SQL.<BR>

<?php $tree -> node(); ?>
Trees can also be generated directly from PHP;<BR>

<?php $tree -> node_last(); ?>
The code works with PHP 4 and PHP 5.

<?php $tree -> directory(); ?>

<DIV class="heading">Tree viewer</DIV>
<?php $tree -> node(); ?>

The <em>tree viewer</em> component generates collapsable,
heirarchical trees on a web pages.<BR>

<?php $tree -> node(); ?>
The <em>tree viewer</em> has its own web page <a href="tree_viewer/index.php">here</a>;

<?php $tree -> node(); ?>
The tree is <em>dynamic</em> - users can:<BR>

<?php
$tree2 = $tree_factory -> web_tree("f");
$tree2 -> collapse_beyond_level(1);
$tree2 -> collapse_all();
$tree2 -> expand_all();
?>

<?php $tree2 -> directory(); ?>
<DIV class="sub_heading">...expand nodes:</DIV>
<?php $tree2 -> node_last(); ?>
...to reveal additional details - or...

<?php $tree2 -> directory_last(); ?>
<DIV class="sub_heading">...collapse nodes:</DIV>

<?php $tree2 -> node_last(); ?>
...to conceal superfluous information.

<?php $tree2 -> node_end(); ?>

<?php $tree -> node(); ?>
Trees can be nested;

<?php $tree -> node(); ?>
Arbitrary HTML can be used in tree nodes;

<?php $tree -> directory_last(); ?>

More details...

<?php $tree -> node(); ?>

All content wraps correctly - without disturbing the tree display;

<?php $tree -> node(); ?>

Trees are presented using a familiar interface - one
immediately familiar to any users who have ever browsed
through the directory structure of their machine's filing
system;

<?php $tree -> node(); ?>

The tree viewer is available as a stand-alone component;

<?php $tree -> node_last(); ?>

Information about which branches of the tree are visible
persists <em>even</em> if the page is left and returned to later.

<?php $tree -> directory(); ?>
<DIV class="heading">Tree editor</DIV>

<?php $tree -> node(); ?>

The <em>tree editor</em> application allows users to create and
manipulate heirarchical trees using an ordinary web browser;

<?php $tree -> node(); ?>
The tree editor has its own web page <a href="tree_editor/index.php">here</a>;

<?php $tree -> node(); ?>

The tree is rendered using the tree viewer component while
it is being edited - providing a degree of "WYSIWYG" editing;

<?php $tree -> node(); ?>

Several sorts of operation are permitted to be performed on the tree:<br>

<?php
$tree2 = $tree_factory -> web_tree("f");
$tree2 -> collapse_beyond_level(1);
$tree2 -> collapse_all();
$tree2 -> expand_all();
?>

<?php $tree2 -> directory(); ?>
<DIV class="sub_heading">Single node-oriented operations:</DIV>

<?php $tree2 -> node_last(); ?>
...allow single "leaves" to be created, manipulated, modified or deleted;

<?php $tree2 -> directory(); ?>
<DIV class="sub_heading">Branch-oriented operations:</DIV>

<?php $tree2 -> node_last(); ?>
...allow branches of the tree to be pruned - or grafted to other locations in the tree;

<?php $tree2 -> directory_last(); ?>
<DIV class="sub_heading">Mass-node operations:</DIV>

<?php $tree2 -> node_last(); ?>
...these allow large numbers of nodes to be manipulated at once.
<?php $tree2 -> node_end(); ?>

<?php $tree -> node_last(); ?>

Branches of the tree can be treated as though they were independent roots;

<?php $tree -> directory(); ?>
<DIV class="heading">Applications</DIV>

<?php $tree -> node(); ?>
Many structures naturally form heirarchical trees:<BR>

<?php
$tree2 = $tree_factory -> web_tree("f");
$tree2 -> collapse_beyond_level(1);
$tree2 -> collapse_all();
$tree2 -> expand_all();
?>

<?php $tree2 -> directory(); ?>
<DIV class="sub_heading">Threaded discussions:</DIV>

<?php $tree2 -> node_last(); ?>

...often posts are made in response to other posts - and a
natural way of rendering the results is a heirarchical tree;

<?php $tree2 -> directory(); ?>
<DIV class="sub_heading">Human family trees:</DIV>

<?php $tree2 -> node_last(); ?>
Here a tree is a natural way of following blood lines;

<?php $tree2 -> directory(); ?>
<DIV class="sub_heading">Nested lists:</DIV>

<?php $tree2 -> node_last(); ?>
In cases where lists can contain other lists, a natural
representaion is a heirarchical tree;

<?php $tree2 -> directory(); ?>
<DIV class="sub_heading">Taxonomical diagrams in biology:</DIV>

<?php $tree2 -> node_last(); ?>
Biological taxonomies are family trees on a grand scale;

<?php $tree2 -> directory(); ?>
<DIV class="sub_heading">Addresses, domains, file paths:</DIV>

<?php $tree2 -> node_last(); ?>
The need to specify addresses as strings often results in
them being arranged into a heirarchical tree;

<?php $tree2 -> directory_last(); ?>
<DIV class="sub_heading">XML/HTML documents</DIV>

<?php $tree2 -> node_last(); ?>
A number of common document formats are structured into elements
which naturally form nested heirarchical trees.

<?php $tree2 -> node_end(); ?>

<?php $tree -> node(); ?>

Collapsable trees also have many applications:<BR>

<?php
$tree2 = $tree_factory -> web_tree("f");
$tree2 -> collapse_beyond_level(1);
$tree2 -> collapse_all();
$tree2 -> expand_all();
?>

<?php $tree2 -> directory(); ?>
<DIV class="sub_heading">Collapsable trees can hide irrelevant information:
</DIV>

<?php $tree2 -> node_last(); ?>

Information such as footnotes or references is often best kept out
of the way of the casual reader.  A collapsable tree can hide this
information - while still keeping it only a click away;

<?php $tree2 -> directory_last(); ?>
<DIV class="sub_heading">Collapsable trees can act as summaries:</DIV>

<?php $tree2 -> node_last(); ?>

A collapsable tree can present a summary initially - while
still allowing readers to "drill down" on the points that
interest them - without swamping them initially with lots of
irrelevant details.

<?php $tree2 -> node_end(); ?>

<?php $tree -> node_last(); ?>

More examples should be available soon - on our planned page of sample applications.

<?php $tree -> directory(); ?>
<DIV class="heading">Sample application</div>

<?php $tree -> node_last(); ?>

Here is a <a href="current_problems/index.php">"problem tracking" application</a> -
rendered using the tree viewer.

<?php $tree -> directory(); ?>

<DIV class="heading">Other sample sites</div>

<?php $tree -> node_last(); ?>

There are a variety of sites using the tree component.<BR>

A list of sample sites is available on the page devoted to the
<a href="tree_viewer/index.php">tree viewer</a>.

<?php $tree -> directory(); ?>

<DIV class="heading">Source code</DIV>

<?php $tree -> node(); ?>

Source code for the tree viewer is available <a href="archive/">here</a>.

<?php $tree -> node_last(); ?>

Source code for the tree editor should be available from this web site soon.

<?php $tree -> directory(); ?>
<DIV class="heading">License</DIV>

<?php $tree -> node_last(); ?>
Everything on this web site has been placed into the public domain by its author.

<?php $tree -> directory(); ?>
<DIV class="heading">Development</DIV>

<?php $tree -> node(); ?>
This program is under active development - and you're welcome to join in.

<?php $tree -> directory_last(); ?>

More details...

<?php $tree -> node(); ?>

The license terms of the code maximise the ease of reusing
this code in other projects.

<?php $tree -> node(); ?>

If you use the code, you are warmly invited to contribute
any constructive changes you make back to the project.<BR>

That way others benefit, the project benefits - and you are
likely to benefit as a user of it.

<?php $tree -> node_last(); ?>

To give some idea of what's planned, here are:<BR>

<?php
$tree2 = $tree_factory -> web_tree("f");
$tree2 -> collapse_beyond_level(99);
?>

<?php $tree2 -> directory(); ?>
Tree viewer

<?php $tree2 -> node(); ?>
...the <a href="tree_viewer/to_do/index.php">"ToDo" list</a>;

<?php $tree2 -> node_last(); ?>


...the list of <a href="tree_editor/known_problems/index.php">known problems</a>;

<?php $tree2 -> directory_last(); ?>

Tree editor

<?php $tree2 -> node(); ?>

...the <a href="tree_editor/to_do/index.php">"ToDo" list</a>;

<?php $tree2 -> node_last(); ?>

...the list of <a href="tree_viewer/known_problems/index.php">known problems</a>.
<?php $tree2 -> node_end(); ?>

<?php $tree -> directory_last(); ?>
<DIV class="heading">Links</DIV>
<?php $tree -> node_last(); ?>
<a href="links/index.php">Links to related material on the web</a>.

<?php
$tree -> node_end();
$tree_factory -> finalise();
?>


<P>
<HR width="25%">
<P>

<address>
<center>
<em><a href="http://timtyler.org/">Tim Tyler</a></em> |
<em><a href="http://timtyler.org/contact/">Contact</a></em> |
<em><a href="http://treeeditor.com/">http://treeeditor.com/</a></em>
</center>
</address>

</td></TR></table></center>

</body>
</html>
