<?php

// This class encapsulates the PEAR database classes.
//
// It allows the ability to extend their functionality
// and offer a customised interface to them.
//
// It also should facilitate switching out PEAR -
// and employing a different database connection technology -
// at a later date - should that prove desirable.

class DatabaseResult {
  var $result;
  function DatabaseResult($result) {
    $this -> result = $result;
  }

  function fetchRow() {
    return $this -> result -> fetchRow();
  }

  function fetchRowAssoc() {
    return $this -> result -> fetchRow(DB_FETCHMODE_ASSOC);
  }

  function numRows() {
    return $this -> result -> numRows($this -> result);
  }

  function free() {
    return $this -> result -> free();
  }

  function isError() {
    return DB::isError($this -> result);
  }

  function getMessage() {
    return $this -> result -> getMessage();
  }
}
?>
