<?php
require_once ("paths.inc.php");
require_once ($path_root."lib/octoploid/php/basic_set_up.inc.php");
require_once ($path_lib_main_php."header.inc.php");
require_once ($path_lib_main_php."include_pear.inc.php");
require_once ($path_lib_main_php."config.inc.php");
require_once ($path_lib_main_php."sessions.inc.php");
require_once ($path_lib_main_php."utilities_get_and_post.inc.php");

$connection = new DatabaseConnection($data_source_name);

$name = ensure_string_from_post('name');
$parent = ensure_string_from_post('parent');

$layout = $_POST['layout'];

update_tree($name, $connection);

relative_redirect('../index.php?layout='.$layout.'&name='.$name.'&parent='.$parent);

die();

function update_tree($table_tree, $connection) {
  $table_name = 'tax_'.$table_tree;
  $query = "SELECT id FROM ".$table_name;
  $result = $connection -> query($query);

  $number_of_rows_found = $result -> numRows();
  for ($idx = 0; $idx < $number_of_rows_found; $idx++) {
    $row = $result -> fetchRowAssoc();
    $id = $row['id'];
    update_node_text($id, $connection, $table_name);
  }
}

function update_node_text($id, $connection, $table_name) {
  $field_name = 'x_'.$id;
  if (isset($_POST[$field_name])) {
    $nid = rand(1,99999999);
    $query = 'INSERT INTO '.$table_name.' SET ';
    $query .= 'id = "'.$nid.'", ';
    $query .= 'parent = "'.$id.'", ';
    $query .= 'rank = "0", ';
    $query .= 'text = "Newly born child"';

    $result = $connection -> query($query);
  }
}
?>
