<?php
require_once ("paths.inc.php");
require_once ($path_root."lib/octoploid/php/basic_set_up.inc.php");
require_once ($path_lib_main_php."header.inc.php");
require_once ($path_lib_main_php."include_pear.inc.php");
require_once ($path_lib_main_php."config.inc.php");
require_once ($path_lib_main_php."sessions.inc.php");
require_once ($path_lib_main_php."utilities_get_and_post.inc.php");

$connection = new DatabaseConnection($data_source_name);

$name = ensure_string_from_post('name');
$parent = ensure_string_from_post('parent');

$layout = $_POST['layout'];

update_tree($name, $connection);

relative_redirect('../index.php?layout='.$layout.'&name='.$name.'&parent='.$parent);

die();

function update_tree($table_tree, $connection) {
  $table_name = 'tax_'.$table_tree;
  $query = "SELECT * FROM ".$table_name;
  $result = $connection -> query($query);

  $number_of_rows_found = $result -> numRows();

  $id_from = '';
  for ($idx = 0; $idx < $number_of_rows_found; $idx++) {
    $row = $result -> fetchRowAssoc();
    $id = $row['id'];

    $field_name = 'x_'.$id;
    if (isset($_POST[$field_name])) {
      if ($id_from == '') {
        $id_from = $id;
      } else {
        graft_nodes($id_from, $id, $connection, $table_name);
        //echo $id_from." ".$id." ".$connection." ".$table_name;
        return; // <--
      }
    }
  }
}

function graft_nodes($id_from, $id_to, $connection, $table_name) {
  $query = 'SELECT rank, parent FROM '.$table_name.' WHERE id = "'.$id_from.'"';
  $result = $connection -> query($query);
  $row = $result -> fetchRowAssoc();
  $from_rank = $row['rank'];
  $from_parent = $row['parent'];

  $query = 'SELECT rank, parent FROM '.$table_name.' WHERE id = "'.$id_to.'"';
  $result = $connection -> query($query);
  $row = $result -> fetchRowAssoc();
  $to_rank = $row['rank'];
  $to_parent = $row['parent'];

  $query = 'UPDATE '.$table_name.' SET rank = "'.$from_rank.'", parent = "'.$from_parent.'" WHERE id = "'.$id_to.'"';
  //echo "<HR>".$query."<HR>";
  $result = $connection -> query($query);

  $query = 'UPDATE '.$table_name.' SET rank = "'.$to_rank.'", parent = "'.$to_parent.'" WHERE id = "'.$id_from.'"';
  //echo "<HR>".$query."<HR>";
  $result = $connection -> query($query);
}
?>
