<?php
require_once ("paths.inc.php");
require_once ($path_root."lib/octoploid/php/basic_set_up.inc.php");
require_once ($path_lib_main_php."header.inc.php");
require_once ($path_lib_main_php."include_pear.inc.php");
require_once ($path_lib_main_php."config.inc.php");
require_once ($path_lib_main_php."safe_text_to_html.inc.php");

$script_name = $_SERVER['SCRIPT_NAME'];
$app_name = "Taxonomy Editor - Help";
include_header($path_root, $path_app, $app_name);
title_image($path_root);
render_app_title($app_name);
?>

<p>

<center>
<Table align="center" width="90%">
<TR>
<TD>

The taxonomy editor is designed to allow editing heirarchical tree structures.<p>

It facilitates the editing of individual nodes - and allows bulk operations on
selected groups of nodes.<p>

An explanation of the buttons used by the taxonomy editor follows:<p>

<center>

<Table align="center" border="1">

<TR>
<TH colspan="2">Selection operations</TH>
</TR>

<TR>
<TD valign="top" align="right"><STRONG>All<STRONG></TD>
<TD>Select all the nodes;</TD>
</TR>

<TR>
<TD valign="top" align="right"><STRONG>None<STRONG></TD>
<TD>Deselect all the nodes;</TD>
</TR>

<TR>
<TH colspan="2">Editing operations</TH>
</TR>

<TR>
<TD valign="top" align="right"><STRONG>Edit<STRONG></TD>
<TD>Edits the selected node(s);</TD>
</TR>

<TR>
<TH colspan="2">Pruning operations</TH>
</TR>

<TR>
<TD valign="top" align="right"><STRONG>Delete<STRONG></TD>
<TD>Deletes the selected node(s).  Any children of the deleted node(s) are adopted by its parent;</TD>
</TR>

<TR>
<TD valign="top" align="right"><STRONG>Prune<STRONG></TD>
<TD>Severes the branch at the selected node(s).  Any children of the pruned node(s) are discarded;</TD>
</TR>

<TR>
<TD valign="top" align="right"><STRONG>Clone<STRONG></TD>
<TD>Dulplicates the selected node(s).  Any children of the cloned node(s) are not duplicated;</TD>
</TR>

<TR>
<TD valign="top" align="right"><STRONG>Birth<STRONG></TD>
<TD>Gives birth to additional node(s);</TD>
</TR>

<TR>
<TD valign="top" align="right"><STRONG>Swap<STRONG></TD>
<TD>Exchance two nodes.  Children of the nodes remain where they were;</TD>
</TR>

<TR>
<TD valign="top" align="right"><STRONG>Graft<STRONG></TD>
<TD>Exchance two branches.  Children of the nodes follow their parent;</TD>
</TR>

<TR>
<TD valign="top" align="right"><STRONG>Up<STRONG></TD>
<TD>Moves children up a generation - so that they are offspring of their grandparents;</TD>
</TR>

</TABLE>
</center>

<P>

For convenience, some of the options are available locally at each node.<p>

These functions can be accessed by clicking on the "&gt" button.<p>

<center>
<Table align="center" border="1">
<TR>
<TD align="right"><STRONG>X<STRONG></TD>
<TD>Prunes;</TD>
</TR>

<TR>
<TD align="right"><STRONG>Edit<STRONG></TD>
<TD>Edit;</TD>
</TR>

<TR>
<TD align="right"><STRONG>Birth<STRONG></TD>
<TD>Birth;</TD>
</TR>

<TR>
<TD align="right"><STRONG>Clone<STRONG></TD>
<TD>Clone;</TD>
</TR>
</TABLE>

<p>

When editing "directory" nodes, there's also a "view"
button.  This starts a new tree editor using that node as a
root.<p>

This can be useful when you want to use the button which
selects all nodes in a tree to select all (or most) nodes
in a particular branch.<p>

</center>


</TD>
</TR>
</TABLE>
</center>

<?php include_footer(); ?>
