<?php
require_once ("paths.inc.php");
require_once ($path_root."lib/octoploid/php/basic_set_up.inc.php");
require_once ($path_lib_main_php."header.inc.php");
require_once ($path_lib_main_php."include_pear.inc.php");
require_once ($path_lib_main_php."config.inc.php");
require_once ($path_lib_main_php."sessions.inc.php");

$connection = db_connect_quick($data_source_name);

$name = ensure_string_from_post('name');
$parent = ensure_string_from_post('parent');

$layout = $_POST['layout'];

update_tree($name, $connection);

relative_redirect('../index.php?layout='.$layout.'&name='.$name.'&parent='.$parent);

die();

function update_tree($table_tree, $connection) {
  $table_name = 'tax_'.$table_tree;
  $query = "SELECT * FROM ".$table_name;
  $result = db_query_quick($connection, $query);

  $number_of_rows_found = db_num_rows($result);
  for ($idx = 0; $idx < $number_of_rows_found; $idx++) {
    $row = db_get_next_row_array($result);
    $id = $row['id'];
    move_children_and_delete($id, $connection, $table_name);
  }
}

function move_children_and_delete($id, $connection, $table_name) {
  $field_name = 'x_'.$id;
  if (isset($_POST[$field_name])) {
    move_to_parent($id, $connection, $table_name);
  }
}

function move_to_parent($id, $connection, $table_name) {
  $query = 'SELECT parent FROM '.$table_name.' WHERE id = "'.$id.'"';
  $result = db_query_quick($connection, $query);
  $row = db_get_next_row_array($result);
  $parent = $row['parent'];

  $query2 = 'SELECT parent FROM '.$table_name.' WHERE id = "'.$parent.'"';
  $result2 = db_query_quick($connection, $query2);
  $row2 = db_get_next_row_array($result2);
  $parent2 = $row2['parent'];

  // give error if no parent here...

  $query = 'UPDATE '.$table_name.' SET parent = "'.$parent2.'", rank = "0" WHERE id = "'.$id.'"';
  //echo "q:".$query;
  $result = db_query_quick($connection, $query);
}
?>
