<?php
require_once ("paths.inc.php");
require_once ($path_root."lib/octoploid/php/basic_set_up.inc.php");
require_once ($path_lib_main_php."header.inc.php");
require_once ($path_lib_main_php."include_pear.inc.php");
require_once ($path_lib_main_php."config.inc.php");
require_once ($path_lib_main_php."sessions.inc.php");
require_once ($path_lib_main_php."utilities_get_and_post.inc.php");

$connection = new DatabaseConnection($data_source_name);

$name = ensure_string_from_post('name');
$parent = ensure_string_from_post('parent');

$layout = $_POST['layout'];

$recursive_updater = new recursive_updater($name, $connection);

$recursive_updater -> update_tree($parent);

relative_redirect('../index.php?layout='.$layout.'&name='.$name.'&parent='.$parent);

die();

class recursive_updater {
  var $table_name;
  var $connection;

  function recursive_updater($table_tree, $connection) {
    $this -> table_name = 'tax_'.$table_tree;
    $this -> connection = $connection;
  }

  function update_tree($parent) {
    $query = 'SELECT * FROM '.$this -> table_name.' WHERE parent="'.$parent.'" ORDER BY rank';
    $result = $this -> connection -> query($query);

    $number_of_rows_found = $result -> numRows();
    for ($idx = 0; $idx < $number_of_rows_found; $idx++) {
      $row = $result -> fetchRowAssoc();
      $id = ''.$row['id'];

      $query2 = 'SELECT COUNT(id) FROM '.$this -> table_name.' WHERE parent="'.$id.'"';
      $result2 = $this -> connection -> query($query2);
      $row2 = $result2 -> fetchRowAssoc();
      $count = $row2['COUNT(id)'];

      $this -> update_node_text($id);
      if ($count > 0) {
        $this -> update_tree($id);
      }
    }
  }

  function update_node_text($id) {
    $field_name = 't_'.$id;
    if (isset($_POST[$field_name])) {
      $insert = addslashes($_POST[$field_name]);
      $query = 'UPDATE '.$this -> table_name.' SET text="'.$insert.'" WHERE id="'.$id.'"';
      $result = $this -> connection -> query($query);
    }
  }
}

?>
