<?php
require_once ("paths.inc.php");
require_once ($path_root."lib/octoploid/php/basic_set_up.inc.php");
require_once ($path_lib_main_php."header.inc.php");
require_once ($path_lib_main_php."include_pear.inc.php");
require_once ($path_lib_main_php."config.inc.php");
require_once ($path_lib_main_php."sessions.inc.php");
require_once ($path_lib_main_php."utilities_get_and_post.inc.php");

$connection = new DatabaseConnection($data_source_name);

$name = ensure_string_from_get('name');

add_taxonomy($name, $connection);

relative_redirect('../index.php');

die();

function add_taxonomy($name, $connection) {
  $table_name = 'tax_'.$name;
  $query =  'DROP TABLE IF EXISTS '.$table_name.';';
  $result = $connection -> query($query);

  $query = 'CREATE TABLE IF NOT EXISTS '.$table_name.' ( ';
  $query .= 'id varchar(20) NOT NULL, ';
  $query .= 'parent varchar(20) default NULL, ';
  $query .= 'rank int(11) NOT NULL default 0, ';
  $query .= 'text blob NOT NULL, ';
  $query .= 'PRIMARY KEY (id) ';
  $query .= ') TYPE=MyISAM;';
  $result = $connection -> query($query);

  $nid = rand(1,999999999);
  //$query = 'INSERT INTO '.$table_name.' VALUES ("'.$nid.'", "root", 1, "Root 1")';
  $query = 'INSERT INTO '.$table_name.' SET id = "'.$nid.'", parent="root", rank=1, text="Root";';
  $result = $connection -> query($query);

  $query = 'INSERT INTO taxonomy_manager VALUES(';
  $query .= '0, \''.$name.'\', \'root\', 1);';
  $result = $connection -> query($query);
}
?>
