<?php
require_once ("paths.inc.php");
require_once ($path_root."lib/octoploid/php/basic_set_up.inc.php");
require_once ($path_lib_main_php."header.inc.php");
require_once ($path_lib_main_php."include_pear.inc.php");
require_once ($path_lib_main_php."config.inc.php");
require_once ($path_lib_main_php."sessions.inc.php");
require_once ($path_lib_main_php."utilities_get_and_post.inc.php");

$connection = new DatabaseConnection($data_source_name);

$name = ensure_string_from_get('name');
$parent = ensure_string_from_get('parent');

prune_branch($name, $parent, $connection);

$query = 'DELETE FROM `taxonomy_manager` WHERE name=\''.$name.'\' AND parent=\''.$parent.'\' ;';
$result = $connection -> query($query);

relative_redirect('../index.php');

die();

function delete_node($id, $connection, $table_name) {
  //echo "DELETING:".$id.'<hr>';
  $query = 'DELETE FROM '.$table_name.' WHERE id = "'.$id.'"';
  $result = $connection -> query($query);
}

function prune_branch($table_tree, $parent, $connection) {
  $table_name = 'tax_'.$table_tree;
  $query = 'SELECT * FROM '.$table_name.' WHERE parent="'.$parent.'" ORDER BY rank';
  $result = $connection -> query($query);
  $number_of_rows_found = $result -> numRows();
  for ($idx = 0; $idx < $number_of_rows_found; $idx++) {
    $row = $result -> fetchRowAssoc();
    $id = $row['id'];

    $query2 = 'SELECT COUNT(id) FROM '.$table_name.' WHERE parent="'.$id.'"';
    $result2 = $connection -> query($query2);
    $row2 = $result2 -> fetchRowAssoc();
    $count = $row2['COUNT(id)'];

    if ($count > 0) {
      prune_branch($table_tree, $id, $connection);
      delete_node($id, $connection, $table_name);
    } else {
      delete_node($id, $connection, $table_name);
    }
  }

  //delete_node($parent, $connection, $table_name);
}

?>
