<HTML>
<HEAD>
<TITLE>Tree Editor - Tree Editor</TITLE>
<link rel="StyleSheet" href="../css/main.css" type="text/css">
</HEAD>
<BODY>
<style>
.black       { background-Color:black }
.transparent { background-Color: }
.title_main {
  color: #4040FF;
  width:100%;
  height:65;
  font-size:32pt;
  font-weight:bold;
  filter:shadow(color="black", strength=10, direction=135)glow(color="black", strength=1);
}
.heading {
  color: #2020C0;
  font-weight:bold;
}
.sub_heading {
  color: #004000;
  font-weight:normal;
}
</style>

<Table cellpadding="0" cellspacing="0" BORDER="0" width="100%" HEIGHT="100%">
<TR>
<TD>

<CENTER>
<Table cellpadding="0" cellspacing="0" BORDER="0" WIDTH="95%" HEIGHT="100%">
<TR>
<TD ALIGN="LEFT" WIDTH="100%">

<CENTER>
<DIV class="title_main">Tree Editor&nbsp;</DIV>
</CENTER>

<center>
<table>
<TR>

<TD>
<table cellpadding="0" cellspacing="0" border="2"><TR><TD><img src="../graphics/thumb_old_tree.jpg" width="64" height="64" border=1></TD></TR></table>
</TD>

<TD>
<table cellpadding="0" cellspacing="0" border="2"><TR><TD><img src="../graphics/thumb_riverine.jpg" width="64" height="64" border=1></TD></TR></table>
</TD>

<TD>
<table cellpadding="0" cellspacing="0" border="2"><TR><TD><img src="../graphics/thumb_coral.jpg" width="64" height="64" border=1></TD></TR></table>
</TD>

<TD>
<table cellpadding="0" cellspacing="0" border="2"><TR><TD><img src="../graphics/thumb_tree.jpg" width="64" height="64" border=1></TD></TR></table>
</TD>

<TD>
<table cellpadding="0" cellspacing="0" border="2"><TR><TD><img src="../graphics/thumb_leaf.jpg" width="64" height="64" border=1></TD></TR></table>
</TD>

<TD>
<table cellpadding="0" cellspacing="0" border="2"><TR><TD><img src="../graphics/thumb_diagram.jpg" width="64" height="64" border=1></TD></TR></table>
</TD>

<TD>
<table cellpadding="0" cellspacing="0" border="2"><TR><TD><img src="../graphics/tree_editor.png" width="64" height="64" border=1></TD></TR></table>
</TD>

</TR></table></center>

<?php
require_once ("paths.inc.php");

$tree_root = $path_root.'lib/tree/';
include_once($tree_root."php/tree_factory.class.php");
$tree_factory = new tree_factory($tree_root);
?>

<CENTER>

<TABLE BORDER="0" CELLPADDING="3" WIDTH="95%">
<TR>
<TD ALIGN="LEFT" WIDTH="100%">

<H3 align="CENTER">An editor of heirarchical trees</H3>

<CENTER>
<TABLE BORDER="2" CELLPADDING="0" CELLSPACING="0">
<TR>
<TD>
<IMG src="graphics/ss.png">
</TD>
</TR>
</table>
The tree editor in action<BR>
</center>
<p>

<H3>Description</H3>

This tree editor allows users to create and manipulate
heirarchical trees using an ordinary web browser.<P>

The tree is rendered using the tree viewer component while
it is being edited - providing a degree of "WYSIWYG"
editing.<p>

<H3>Operation</H3>

Individual nodes can be created, manipulated, moved and
deleted - and there are also a range of operations which act
on multiple nodes at once.<p>

These are mostly controlled using the checkboxes at the
side of each item - and the buttons at the bottom.<p>

The available controls look like this:<p>

<CENTER>
<TABLE BORDER="2" CELLPADDING="0" CELLSPACING="0">
<TR>
<TD>
<IMG src="graphics/controls.png">
</TD>
</TR>
</table>
The tree editor's control buttons<BR>
</center>
<p>

Details of what each of these buttons does to the selected nodes is
covered in the help text - which is available
<a href="../taxonomy_editor/help/index.php">here</a>.<p>

There's also a tree manager - which allows multiple trees to be created
and managed.<p>


<H3>Demonstration</H3>

A demonstration of the tree editor is available online
<a href="../taxonomy_manager/index.php">here</a>.<p>

This demonstration is fully functional.  However the
demonstration trees that are created are liable to being
periodically reset - so you are advised not to use them to
store anything important.<p>


<H3>Source code</H3>

A zip file containing all the relevant files is available
<a href="../archive/">here</a>.<p>


<H3>License</H3>

This program and its source code have been placed into the
public domain by its author.<p>


</TD></TR></TABLE></center>

<P>
<hr align=center width="25%">
<P>

<address>
<center>
<em><a href="http://timtyler.org/">Tim Tyler</a></em> |
<em><a href="http://timtyler.org/contact/">Contact</a></em> |
<em><a href="http://treeeditor.com/">http://treeeditor.com/</a></em>
</center>
</address>

</TD></TR></TABLE></center>

</body>
</html>

