<script type="text/javascript">
<!--
function showParam(i) {
  currentParam = i;
  document.getElementById('param').style.display = ''
  document.getElementById('param').innerHTML = '<pre>' + document.getElementById('param' + i).innerHTML + '</pre>'
}

function hideParam() {
  currentParam = -1;
  document.getElementById('param').style.display = 'none'
}

function showOrHideParam(i) {
  if (currentParam == i) {
    hideParam()
  } else {
    showParam(i)
  }
}

function showDetails(cnt) {
  for (i = 0; i < cnt; ++i) {
    eval('document.getElementById("file' + i + '").style.display = ""')
  }
}

function hideDetails(cnt) {
  for (i = 0; i < cnt; ++i) {
    eval('document.getElementById("file' + i + '").style.display = "none"')
  }
}

var currentParam = -1;
//-->
</script>

<pre>

<hr>

<b>Error type:</b> <?php echo $errType[$errNo]; ?>

<?php

  function fontStart($color) {
      return '<font color="'.$color.'">';
  }
  function fontEnd() {
      return '</font>';
  }

  $c['default'] = '#303030';
  $c['keyword'] = '#0000FF';
  $c['number']  = '#800080';
  $c['string']  = '#404040';
  $c['comment'] = '#808080';

  if (count($info)) {
    foreach ($info as $k => $v) {
      echo '<b>';
      echo $k;
      echo ':</b> ';
      echo $v;
      echo "\r\n";
    }
  } else {
    echo '<b>Error message:</b> ';
    echo $errMsg;
    echo "\r\n";
  }

  echo "\r\n";

  if (count($trace)) {
    echo '<ul>';
    $currentParam = -1;
    foreach ($trace as $k => $v) {
      $currentParam++;
      echo '<li style="list-style-type: square;">';

      if (isset($v['class'])) {
          echo '<span style="color: '.$c['keyword'].';" >';
          echo $v['class'];
          echo ".";
      } else {
          echo '<span style="color: '.$c['keyword'].';" >';
      }

      echo $v['function'];
      echo '</span>';
      echo " (";

      $sep = '';
      $v['args'] = (array) @$v['args'];
      foreach ($v['args'] as $arg) {
        $currentParam++;

        echo $sep;
        $sep    = ', ';
        $color = '#404040';

        switch (true) {
          case is_bool($arg):
            $param  = 'TRUE';
            $string = $param;
            break;

          case is_int($arg):
          case is_float($arg):
            $param  = $arg;
            $string = $arg;
            $color = $c['number'];
            break;

          case is_null($arg):
            $param = 'NULL';
            $string = $param;
            break;

          case is_string($arg):
            $param = $arg;
            $string = 'string['.strlen($arg).']';
            break;

          case is_array($arg):
            ob_start();
            //print_r($arg); //insecure...
            $param = ob_get_contents();
            ob_end_clean();
            $string = 'array['.count($arg).']';
            break;

          case is_object($arg):
            ob_start();
            //print_r($arg); //insecure...
            $param = ob_get_contents();
            ob_end_clean();
            $string = 'object: '.get_class($arg);
            break;

          case is_resource($arg):
            $param = 'resource: '.get_resource_type($arg);
            $string = 'resource';
            break;

          default:
            $param = 'unknown';
            $string = $param;
            break;
        }

        echo '<span style="cursor: pointer; color: '.$color.';" onclick="showOrHideParam('.$currentParam.')" onmouseout="this.style.color=\''.$color.'\'" onmouseover="this.style.color=\'#dd0000\'">';
        echo $string;
        echo '</span>';
        echo '<span id="param'.$currentParam.'" style="display: none;">'.$param.'</span>';
      }

      echo ")";
      echo "\r\n";

      if (!isset($v['file'])) {
          $v['file'] = 'unknown';
      }
      if (!isset($v['line'])) {
          $v['line'] = 'unknown';
      }

      $v['line'] = @$v['line'];
      $path = $v['file'];
      echo '<span id="file'.$k.'" style="display: block; color: #808080;">';
      echo '['.fontStart('#408040').$v['line'].fontEnd().']';
      echo ' : ';
      echo '<a href="file://'.$path.'">'.$path.'</a> ';
      echo '</span>';
      echo '</li>';
    }

    echo '</ul>';

  } else {
    echo '<b>File:</b> ';
    echo basename($file);
    echo ' ('.$line.') ';
    echo dirname($file);
  }
?>
<hr>
<div id="param" perm="0" style="background-color: #000000; color: #00FF00; padding: 2px; display: block;">&nbsp;</div><hr>
</pre>
