<?php
function navigation_controls($path_to_root, $script_name, $nav_cond, $count,
                             $max_displayed, $page_number,
                             $number_of_other_pages) {
	if($page_number > 0) {
	  echo "<a href=\"$script_name?$nav_cond&page_number=0\"><img border=0 src=\"".
	    $path_to_root."graphics/buttons/first.png\" width=20 height=20></a> ";
	  echo "<a href=\"$script_name?$nav_cond&page_number=".($page_number - 1).
	    "\"><img border=0 src=\"".$path_to_root."graphics/buttons/previous.png\"
	    width=20 height=20></a> ";
	}
	else
	{
	  echo "<img src=\"".$path_to_root."graphics/buttons/first_disabled.png\"
	    width=20 height=20> ";
	  echo "<img src=\"".$path_to_root."graphics/buttons/previous_disabled.png\"
	    width=20 height=20> ";
	}

  $total_pages = floor($count / $max_displayed) + 1;

  echo "&nbsp;<font size='+1'><strong>";

  $number_of_other_pages_before = floor($number_of_other_pages / 2);
  $number_of_other_pages_after = $number_of_other_pages -
                                 $number_of_other_pages_before;

  $start = $page_number - $number_of_other_pages_before;
  $end = $page_number + $number_of_other_pages_after;

  if ($start < 0) {
    $start = 0;
    $end = $number_of_other_pages;
  }

  if ($end > $total_pages) {
    $end = $total_pages;
    $start = $total_pages - $number_of_other_pages;
  }

  if ($start < 0) {
    $start = 0;
  }

  //echo "start:".$start;
  //echo "total_pages:".$total_pages;

  for ($i = $start; $i < $end; $i++) {
    if ($i != $page_number) {
      echo "<a href='".$script_name."?".
        $nav_cond."&page_number=".$i."'>".($i + 1)."</a> ";
    } else {
      echo ($i + 1)." ";
    }

    if (($i + 1) < $end) {
      echo "| ";
    }
  }

  echo "</strong></font>&nbsp;";

	$mxs = $max_displayed * ($page_number + 1);

	if($mxs <= $count) {
	  echo "<a href=\"$script_name?".$nav_cond."&page_number=".
	    ($page_number + 1)."\"><img border=0 src=\"".$path_to_root.
	    "graphics/buttons/next.png\" width=20 height=20></a> ";
	  echo "<a href=\"$script_name?".$nav_cond."&page_number=".
	    ($total_pages - 1)."\"><img border=0 src=\"".$path_to_root.
	    "graphics/buttons/last.png\" width=20 height=20></a> ";
	}
	else
	{
	  echo "<img src=\"".$path_to_root.
	    "graphics/buttons/next_disabled.png\" width=20 height=20> ";
	  echo "<img src=\"".$path_to_root.
	    "graphics/buttons/last_disabled.png\" width=20 height=20> ";
	}
}
?>
