<?php // This material has been placed into the public domain by its author.
//error_reporting (E_ALL); // for debugging...

class tree_factory {
  var $lib_path;
  var $t_array;
  var $index = 0;

  function tree_factory($lib_path) {
    $this -> lib_path = $lib_path;
?>
<script language="JavaScript" type="text/javascript" src="<?php echo $lib_path; ?>js/tree_lib.js">
</script>
<script language="JavaScript" type="text/javascript">
var image_directory = "<?php echo $this -> get_image_directory(); ?>";
</script>
<?php
  }

  function web_tree($layout) {
    $name = "t_" + $this -> index;
    $wt = new tree($name, $this -> get_image_directory(), $this);
    $wt -> layout = $layout;
    $this -> t_array[$this -> index] = $name;
    $this -> index = ($this -> index) + 1;
    return $wt;
  }

  function finalise() {
    $length = sizeof($this -> t_array);
?>
<script language="JavaScript" type="text/javascript">
//<!--
function t_set_up() {
<?php
  for ($i = 0; $i < $length; $i++) {
    echo "restore_state_from_form_fields('".($this -> t_array[$i])."');\n";
  }
?>

preload_image("t_n_m_1_mi.png");
preload_image("t_n_m_1_pl.png");
preload_image("t_n_m_9_mi.png");
preload_image("t_n_m_9_pl.png");

preload_image("t_col_all_sel.png");
preload_image("t_exp_all_sel.png");
preload_image("t_n_l_sel.png");
preload_image("t_n_m_1_mi_sel.png");
preload_image("t_n_m_1_pl_sel.png");
preload_image("t_n_m_9_mi_sel.png");
preload_image("t_n_m_9_pl_sel.png");
preload_image("t_op_as_far_as_sel.png");
preload_image("t_n_r_sel.png");

preload_image("toggle_pl_sel.png");
preload_image("toggle_mi_sel.png");

window.status = "";
}

setTimeout("t_set_up()", 10);
//-->
</script>
<?php
  }

  function opening_js_fragment($open) {
    $image_directory = $this -> get_image_directory();
    if ($open != null) {
      if ($open != "") {
        echo "open_named_node('".$open."','".$image_directory."');\n";
      }
    }
  }

  function get_image_directory() {
    return $this -> lib_path."images/";
  }
}

class tree {
  var $row = 1;
  var $level = 1;
  var $last;
  var $last_flag = false;
  var $name;
  var $image_directory;
  var $there_are_more;
  var $last_object_type;
  var $collapse_beyond = 0;
  var $parent;
  var $in_progress = false;
  var $tree_started = false;
  var $name_of_9_node;
  var $node_found = false;
  var $debug = false;
  var $testing = true;
  var $layout = "";

  function tree($name, $image_directory, $parent) {
  	$this -> name = $name;
  	$this -> parent = $parent;
  	$this -> image_directory = $image_directory;
  	$this -> last[1] = false;
?>
<?php
  }

  function node() {
    if ($this -> tree_started) {
      $this -> internal_n_m();
    } else {
      $this -> internal_n_1();
    }

    $this -> internal_set_last_flag(false);
    $this -> node_found = true;
  }

  function node_last() {
    $this -> internal_n_start();
    $this -> internal_object_start_exit();
    $this -> internal_set_last_flag(true);
    $this -> node_found = true;
  }

  function node_end() {
    //if ($this -> debug) echo '<BR><FONT size="-6">OBJECT_END</font>';

    if ($this -> last_object_type == "object") {
      $this -> internal_object_end();
    } else {
      $this -> directory_end();
    }
    $this -> in_progress = false;
  }

  function directory($name_of_node = "") {
    if ($name_of_node == "") {
      $name_of_node = $this -> internal_get_name_of_node($this -> name, ($this -> row) + 0);
    }

    $this -> internal_directory(true, $name_of_node);
    $this -> internal_set_9_level(false);
    $this -> node_found = false;
  }

  function directory_last($name_of_node = "") {
    if ($name_of_node == "") {
      $name_of_node = $this -> internal_get_name_of_node($this -> name, ($this -> row) + 0);
    }

    $this -> internal_directory(false, $name_of_node);
    $this -> internal_set_9_level(true);
    $this -> node_found = false;
  }

  function directory_end() {
    $row = $this -> row;
    $name = $this -> name;
    $there_are_more = $this -> there_are_more;
?>
</td></TR>
</table>
</td></TR></table>
</td></TR>
</table></TD>
</tr>

<?php
  if ($this -> debug) echo '<tr><TD><FONT size="-6">TITLE_END</font></TD></TR>';
?>
<tr>
<td colspan="1" align="left" valign="top">
<div id="t_<?php echo $name."_".$row; ?>_son" class="treemenudiv">
<?php
    $this -> internal_directory_common_start_code();
    $this -> row = ($this -> row) + 1;
  }

  function expand_all() {
    $name = $this -> name;
    $image_directory = $this -> image_directory;
?><img id="t_<?php echo $name; ?>_expand_all" onmouseover="t_select_element_and_set_status('t_<?php echo $name; ?>_expand_all','Expand all the nodes in the tree');" onmouseout="t_deselect_element_and_status('t_<?php echo $name; ?>_expand_all');" align="top" border="0" src="<?php echo $image_directory; ?>t_exp_all.png" width="18" height="18" alt="Expand all tree nodes" onclick="expand_all_nodes('<?php echo $name; ?>');" alt="Expand all"/><?php
  }

  function collapse_all() {
    $name = $this -> name;
    $image_directory = $this -> image_directory;
?><img id="t_<?php echo $name; ?>_collapse_all" onmouseover="t_select_element_and_set_status('t_<?php echo $name; ?>_collapse_all','Collapse all the nodes in the tree');" onmouseout="t_deselect_element_and_status('t_<?php echo $name; ?>_collapse_all');" align="top" border="0" src="<?php echo $image_directory; ?>t_col_all.png" width="18" height="18" alt="Collapse all tree nodes" onclick="collapse_all_nodes('<?php echo $name; ?>');" alt="Collapse all"/><?php
  }

  function open_as_far_as($level) {
    $name = $this -> name;
    $image_directory = $this -> image_directory;
?><img id="t_<?php echo $name; ?>_op_as_far_as_<?php echo $level; ?>" onmouseover="t_select_element_and_set_status('t_<?php echo $name; ?>_op_as_far_as_<?php echo $level; ?>', 'Expand nodes in the tree as far as level <?php echo $level; ?>');" onmouseout="t_deselect_element_and_status('t_<?php echo $name; ?>_op_as_far_as_<?php echo $level; ?>');" align="top" border="0" src="<?php echo $image_directory; ?>t_op_as_far_as.png" width="18" height="18" onclick="open_as_far_as('<?php echo $name; ?>','<?php echo $level; ?>');" alt="Expand as far as level <?php echo $level; ?>"/><?php
  }

  function toggle_descendant_controls() {
    $name = $this -> name;
    $image_directory = $this -> image_directory;
?><img id="t_<?php echo $name; ?>_t_d_c" onmouseover="t_select_element_and_set_status('t_<?php echo $name; ?>_t_d_c', 'Toggle descendant controls');" onmouseout="t_deselect_element_and_status('t_<?php echo $name; ?>_t_d_c');" align="top" border="0" src="<?php echo $image_directory; ?>t_ctrl.png" width="18" height="18" onclick="t_d_c('<?php echo $name; ?>');" alt="Toggle descendant controls"/><?php
  }

  function open_descendants($node = "") {
  if ($node == "") {
    $node = $this -> name_of_9_node;
  }
  $name = $this -> name;
  $image_directory = $this -> image_directory;
?><img style="display:none" id="t_<?php echo $name; ?>_op_descendants_of_<?php echo $node; ?>" onmouseover="t_select_element_and_set_status('t_<?php echo $name; ?>_op_descendants_of_<?php echo $node; ?>','Expand all the descendants of this node');" onmouseout="t_deselect_element_and_status('t_<?php echo $name; ?>_op_descendants_of_<?php echo $node; ?>');" align="top" border="0" src="<?php echo $image_directory; ?>t_exp_all.png" width="18" height="18" onclick="open_descendants_of('<?php echo $node; ?>');" alt="Open descendants:<?php echo $node; ?>"/><?php
  }

  function close_descendants($node = "") {
  if ($node == "") {
    $node = $this -> name_of_9_node;
  }
  $name = $this -> name;
  $image_directory = $this -> image_directory;
?><img style="display:none" id="t_<?php echo $name; ?>_close_descendants_of_<?php echo $node; ?>" onmouseover="t_select_element_and_set_status('t_<?php echo $name; ?>_close_descendants_of_<?php echo $node; ?>','Collapse all the descendants of this node');" onmouseout="t_deselect_element_and_status('t_<?php echo $name; ?>_close_descendants_of_<?php echo $node; ?>');" align="top" border="0" src="<?php echo $image_directory; ?>t_col_all.png" width="18" height="18" onclick="close_descendants_of('<?php echo $node; ?>');" alt="Close descendants:<?php echo $node; ?>"/><?php
  }

  function collapse_beyond_level($level) {
    $this -> collapse_beyond = $level;
  }

  function internal_object_end() {
    echo '</td></TR>';
    if ($this -> debug) echo '<tr><TD><FONT size="-6">NODE_END</font></TD></TR>'; //  TEST!!
    echo '</table></TD>';

    if ((!$this -> testing) ^ ($this -> is_horizontal_row_of_cells($this -> level))) {
      echo '</tr>';
    }

    if ($this -> last_flag) {
      $this -> internal_decrease_level();
      while ($this -> last[$this -> level + 1]) {
        $this -> internal_decrease_level();
      }
    }
  }

  function internal_decrease_level() {
    if ($this -> debug) echo '<tr><TD><FONT size="-6">LEVEL_END ('.$this -> level.')</font></TD></TR>';
    $this -> level -= 1;

    if (($this -> testing) ^ ($this -> is_horizontal_row_of_cells($this -> level))) {
      echo '</tr>';
    }

    echo '</table></div>';

    if ((!$this -> testing) ^ ($this -> is_horizontal_row_of_cells($this -> level))) {
      echo '</tD></tr>';
    }

    if ($this -> debug) echo '</TR><tr><TD><FONT size="-6">DIRECTORY_END</font></TD>';

    //echo '</table></tD></TR>'; // TABLE_DIRECTORY_END
    echo '</table>'; // TABLE_DIRECTORY_END
    //echo '</tD></TR></table>'; // TABLE_DIRECTORY_END

    if (($this -> level) < 1) {
      $this -> internal_end();
    }
  }

  function internal_n_start() {
    if ($this -> in_progress) {
      $this -> node_end();
    } else {
      if ($this -> debug) echo '<tr><TD>Node first! (Never called?)</TD></TR>';
    }

    $this -> in_progress = true;

    if ((!$this -> testing) ^ ($this -> is_horizontal_row_of_cells($this -> level))) {
      echo '<tr>';
    }
  }

  function internal_n_1() {
    $this -> tree_started = true;
    echo '<table cellspacing="0" cellpadding="0" border="0" width="100%" bgcolor="#ff0000">';
    if ($this -> debug) echo '<tr><TD>Node first! (Never called?)</TD></TR>';
    $this -> internal_n_start();
    $this -> internal_object_start_exit();
  }

  function internal_n_m() {
    $this -> internal_n_start();
    $this -> internal_object_start_exit();
  }

  function internal_object_start_exit() {
    echo '<td valign="top">';
    echo '<table border="0" cellspacing="0" cellpadding="0" border="0" width="100%">';
    if ($this -> debug) echo '<tr><TD><FONT size="-6">NODE_START</font></TD></TR>';
    echo '<tr>';
    echo '<TD valign="top">';
    //if ($this -> debug) echo '<FONT size="-6">OBJECT_START</font><BR>';
    $this -> last_object_type = "object";
  }

  function internal_directory($there_are_more, $name_of_node = "x") {
    if ($this -> tree_started) {
      $this -> internal_directory_start("toggle_mi.png", $there_are_more, $name_of_node);
    } else {
      $this -> internal_directory_1($name_of_node, $there_are_more);
    }
  }

  function internal_directory_start($icon, $there_are_more, $name_of_node) {
    if ($this -> in_progress) {
      $this -> node_end();
    }

    $this -> in_progress = true;

    $row = $this -> row;
    $name = $this -> name;
    $level = $this -> level;
    $image_directory = $this -> image_directory;
    $this -> there_are_more = $there_are_more;
    $this -> last_object_type = "directory";
    $this -> name_of_9_node = $name_of_node;

    if ($this -> debug) echo '<tr><TD><FONT size="-6">DIRECTORY_START</font></TD></TR>';
    if ($this -> debug) echo '<tr><TD><FONT size="-6">TITLE_START</font></TD></TR>';

    if ((!$this -> testing) ^ ($this -> is_horizontal_row_of_cells($this -> level))) {
      echo '<tr>';
    }
?>

<a name="<?php echo $name_of_node; ?>">
<input type="hidden" id="t_<?php echo $name."_".$row; ?>_f" value="i">
<input type="hidden" id="t_<?php echo $name."_".$row; ?>_l" value="<?php echo $level; ?>">
<input type="hidden" id="<?php echo 't_'.$name_of_node; ?>" value="<?php echo $name; ?>">
<input type="hidden" id="<?php echo  'r_'.$name_of_node; ?>" value="<?php echo $row; ?>">

<TD colspan="1" valign="top">
<?php
  echo '<table cellspacing="1" cellpadding="1" width="100%" border="1" bgcolor="#F0F0F0"><TR><TD>'; // TABLE_DIRECTORY_START
?>


<table width="100%" cellspacing="0" cellpadding="0" border="0" bgcolor="#C0C0C0"><TR><TD>
<table width="100%" cellspacing="0" cellpadding="0" border="0" bgcolor="#C0C0C0"><TR><TD>
<td valign="top" width="18"><table cellspacing="0" cellpadding="0" border="0" onmouseover="t_select(<?php echo "'$name','$row'"; ?>)" onmouseout="t_deselect(<?php echo "'$name','$row'"; ?>)"  width="2"><tr><TD valign="top" width="2"><a onmousedown="tog_t_menu(<?php echo "'$name','$row'"; ?>)"><img align="top" valign="top" border="0" id="t_<?php echo $name."_".$row; ?>_n" src="<?php echo $image_directory; ?><?php echo $icon; ?>" width="18" height="18" alt="Collapse" /></a></td></tR></TABLE></td>

<td><table width="100%" cellspacing="0" cellpadding="0" border="0"><tr>
<TD valign="top" align="left">
<?php
  //if ($this -> debug) echo '<FONT size="-6">OBJECT_START [DIR]</font><BR>';
    $this -> level += 1;
  }

  function internal_set_last_flag($bool) {
    $this -> last_flag = $bool;
  }

  function internal_set_9_level($bool) {
    $this -> last[$this -> level] = $bool;
  }

  function internal_directory_1($name_of_node = "x", $there_are_more = true) {
    $this -> internal_directory_common_start_code();
    $this -> internal_directory_start("toggle_mi.png", $there_are_more, $name_of_node);
  }

  function internal_directory_common_start_code() {
    $this -> tree_started = true;
    echo '<table cellspacing="1" cellpadding="1" width="100%" border="0" bgcolor="#F0F0F0">';
    if ($this -> debug) echo '<tr><TD><FONT size="-6">LEVEL_START ('.(($this -> level) + 0).')</font></TD></TR>';


    if (($this -> testing) ^ ($this -> is_horizontal_row_of_cells($this -> level))) {
      echo '<tr>';
    }
  }

  function internal_get_name_of_node($name, $row) {
    return "t_".$name."_".$row."_x";
  }

  function get_toggle_method_call() {
    $name = $this -> name;
    $row = $this -> row;
    return "tog_t_menu('".$name."','".$row."')";
  }

  function is_horizontal_row_of_cells($depth) {
    if ($this -> layout == "h") return false;
    if ($this -> layout == "v") return true;
    if ($this -> layout == "1") return (($depth & 1) != 0);

    return (($depth & 1) == 0);
  }

  function internal_end() {
    $name = $this -> name;
    $row = $this -> row;
    $image_directory = $this -> image_directory;
    $open = @$_GET['open'];
?>
<input type="hidden" id="t_<?php echo $name; ?>_r_total" value="<?php echo $row; ?>">
<script language="JavaScript" type="text/javascript">
//<!--
initially_collapse_all_nodes("<?php echo $name; ?>",<?php echo $this -> collapse_beyond; ?>,99);
set_up_nodes_not_in_range("<?php echo $name; ?>","i",<?php echo $this -> collapse_beyond; ?>,99);
<?php $this -> parent -> opening_js_fragment($open); ?>
//-->
</script>
<?php
  }
}
?>
