<?php
require_once ("paths.inc.php");
require_once ($path_root."lib/octoploid/php/basic_set_up.inc.php");
require_once ($path_lib_main_php."header.inc.php");
require_once ($path_lib_main_php."include_pear.inc.php");
require_once ($path_lib_main_php."config.inc.php");
require_once ($path_lib_main_php."sessions.inc.php");

$script_name = $_SERVER['SCRIPT_NAME'];

$connection = db_connect_quick($data_source_name);

$table_tree = $_POST['table_tree'];

$layout = $_POST['layout'];

$parent = ensure_string_from_post('parent');

update_tree($parent, $table_tree, $connection);

header('Location: ../index.php?&layout='.$layout.'&just_updated=y');
die();

function update_tree($parent, $table_tree, $connection) {
  $table_name = 'tax_'.$table_tree;
  $query = "SELECT * FROM ".$table_name." WHERE parent='$parent' ORDER BY rank";
  $result = db_query_quick($connection, $query);

  $number_of_rows_found = db_num_rows($result);
  for ($idx = 0; $idx < $number_of_rows_found; $idx++) {
    $row = db_get_next_row_array($result);
    $id = $row['id'];

    $query2 = "SELECT COUNT(id) FROM ".$table_name." WHERE parent='$id'";
    $result2 = db_query_quick($connection, $query2);
    $row2 = db_get_next_row_array($result2);
    $count = $row2['COUNT(id)'];
    //echo 'id:'.$id.'<BR>';

    update_node_text($id, $connection, $table_name);
    if ($count > 0) {
      update_tree($id, $table_tree, $connection);
    }
  }
}

function update_node_text($id, $connection, $table_name) {
  $field_name = 'n_'.$id;
  if (isset($_POST[$field_name])) {
     $insert = $_POST[$field_name];
     $query = 'UPDATE '.$table_name.' SET name = "'.$insert.'" WHERE id = "'.$id.'"';
     $result = db_query_quick($connection, $query);
  }

  $field_name = 'p_'.$id;
  if (isset($_POST[$field_name])) {
     $insert = $_POST[$field_name];
     $query = 'UPDATE '.$table_name.' SET parent = "'.$insert.'" WHERE id = "'.$id.'"';
     $result = db_query_quick($connection, $query);
  }

  $field_name = 'r_'.$id;
  if (isset($_POST[$field_name])) {
     $insert = $_POST[$field_name];
     $query = 'UPDATE '.$table_name.' SET rank = "'.$insert.'" WHERE id = "'.$id.'"';
     $result = db_query_quick($connection, $query);
  }

  $field_name = 't_'.$id;
  if (isset($_POST[$field_name])) {
     $insert = $_POST[$field_name];
     $query = 'UPDATE '.$table_name.' SET text = "'.$insert.'" WHERE id = "'.$id.'"';
     $result = db_query_quick($connection, $query);
  }
}

//$query_string = $_SERVER['QUERY_STRING'];

?>
