<?php
require_once ("paths.inc.php");
require_once ($path_root."lib/octoploid/php/basic_set_up.inc.php");
require_once ($path_lib_main_php."header.inc.php");
require_once ($path_lib_main_php."include_pear.inc.php");
require_once ($path_lib_main_php."config.inc.php");
require_once ($path_lib_main_php."logged_in_message.inc.php");
require_once ($path_lib_main_php."date_chooser.inc.php");
require_once ($path_lib_main_php."navigation_controls.inc.php");
require_once ($path_lib_main_php."utilities_get_and_post.inc.php");

$script_name = $_SERVER['SCRIPT_NAME'];
$app_name = "Taxonomy Manager";
include_header($path_root, $path_app, $app_name);
title_image($path_root);
render_app_title($app_name);

$coach_email  = ensure_string_from_get('coach_email');
$caller_email = ensure_string_from_get('caller_email');
$problem      = ensure_string_from_get('problem');
$sw_version   = ensure_string_from_get('sw_version');
$os_version   = ensure_string_from_get('os_version');

?>
<P>
<center>
<form name="add_new_taxonomy" method="GET" action="add_taxonomy/index.php">
Create a new taxonomy:
<input type="text" name="name" size="12" value="">

<INPUT style="FONT-SIZE: 16px" TYPE="SUBMIT" name="Operation" VALUE="Add">
</FORM>
<P>
<?php

$connection = new DatabaseConnection($data_source_name);

$query = 'SELECT DISTINCT name, editable FROM taxonomy_manager ORDER BY name';
$result = $connection -> query($query);
//echo '<center>';
echo '<TABLE border="0">';

$number_of_rows_found = $result -> numRows();
$demo = true;
for ($idx = 0; $idx < $number_of_rows_found; $idx++) {
  //echo '<UL>';
  $row = $result -> fetchRowAssoc();
  $name = $row['name'];
  $editable = $row['editable'];
  if ($editable || !$demo) {
    echo '<TR>';
    echo '<form name="delete" method="GET" action="taxonomy_delete/index.php">';
    echo '<TD>';
    echo '* ';
    echo '<STRONG>'.$name.'</STRONG>';
    echo '</TD>';
    echo '<TD>';
    echo ' <input type="hidden" name="name" size="12" value="'.$name.'">';
    echo ' <INPUT style="FONT-SIZE: 16px" TYPE="SUBMIT" name="Operation" VALUE="Delete"  onclick="return confirm(\'Are you sure you want to delete this taxonomy?\');";>';

    echo '</TD>';
    echo '</FORM>';

    echo '<form name="add_new_root" method="GET" action="add_root/index.php">';
    echo '<TD>';
    echo ' <input type="hidden" name="name" size="12" value="'.$name.'">';
    echo ' <input type="text" name="root" size="12" value="">';
    echo ' <INPUT style="FONT-SIZE: 16px" TYPE="SUBMIT" name="Operation" VALUE="Add root">';

    echo '</TD>';
    echo '</FORM>';
    echo '</TR>';

    $query2 = 'SELECT * FROM taxonomy_manager WHERE name="'.$name.'" ORDER BY parent';
    //echo "<HR>".$query2."<HR>";
    $result2 = $connection -> query($query2);

    $number_of_rows_found2 = $result2 -> numRows();
    //echo "<HR>".$number_of_rows_found2."<HR>";
    for ($idx2 = 0; $idx2 < $number_of_rows_found2; $idx2++) {
      $row2 = $result2 -> fetchRowAssoc();
      $parent = $row2['parent'];
      //$editable = $row2['editable'];

      echo '<TR>';
      echo '<form name="change_root" method="GET" action="root_delete/index.php">';
      echo '<TD>';
      echo '&nbsp; * ';
      echo '<a href="../taxonomy_editor/index.php?name='.$name.'&parent='.$parent.'">'.$parent.'</a>';
  //    echo $parent;
      echo '</TD>';
      echo '<TD>';
      echo ' <input type="hidden" name="name" value="'.$name.'">';
      echo ' <input type="hidden" name="parent" value="'.$parent.'">';
      //if ($editable) {
        echo ' <INPUT style="FONT-SIZE: 16px" TYPE="SUBMIT" name="Operation" VALUE="Delete" onclick="return confirm(\'Are you sure you want to delete this root?\');";>';
      //}
      echo '</TD>';
      echo '</FORM>';
      echo '<form name="edit" method="GET" action="../taxonomy_editor/index.php">';
      echo ' <input type="hidden" name="name" value="'.$name.'">';
      echo ' <input type="hidden" name="parent" value="'.$parent.'">';
      echo '<TD>';
      //if ($editable) {
        echo ' <INPUT style="FONT-SIZE: 16px" TYPE="SUBMIT" name="Operation" VALUE="Edit">';
      //}
      echo '</TD>';
      echo '</FORM>';
      echo '</TR>';
    }
  }
  //echo '</UL>';
}

//echo '</UL>';
//echo '</TD>';
//echo '</TR>';
echo '</TABLE>';

?>

</CENTER>

</BODY>
</HTML>
